#include <acknex.h>
#include <custom_controls.c>

BMAP* pb_tga = "point_blue.tga";		BMAP* pg_tga = "point_green.tga";	BMAP* pr_tga = "point_red.tga";	BMAP* py_tga = "point_yellow.tga";	
PANEL* L_pan[300];						PANEL* Lpan;								PANEL* Lan;

PANEL* background1_pan = // displays the black starry background
{bmap = "background.tga";	layer = 10;	pos_x = 0;	pos_y = 0;	flags = VISIBLE;}

///BUTTON FFUNCTIONS
function button_0FF(){while(mouse_left){wait(1);}switching_controls[0] = 1;}		//Switch Controls of the key 0
function button_1FF(){while(mouse_left){wait(1);}switching_controls[1] = 1;}		//Switch Controls of the key 1
function button_2FF(){while(mouse_left){wait(1);}switching_controls[2] = 1;}		//Switch Controls of the key 2
function button_3FF(){while(mouse_left){wait(1);}switching_controls[3] = 1;}		//Switch Controls of the key 3
function button_4FF(){while(mouse_left){wait(1);}reset_key_values(4);}				//Reset Values
function button_5FF(){while(mouse_left){wait(1);}sys_exit(NULL);}						//Exit program

function Change_Keys_PANEL()
{
	//JUST FOR THE EXAMPLE/////////////////////////////////////////////////
	L_pan[0] = pan_create("bmap = pb_tga;pos_y = 200;pos_x = 200;", 30); // 
	L_pan[1] = pan_create("bmap = pb_tga;pos_y = 270;pos_x = 130;", 30); // 
	L_pan[2] = pan_create("bmap = pb_tga;pos_y = 270;pos_x = 200;", 30); //
	L_pan[3] = pan_create("bmap = pb_tga;pos_y = 270;pos_x = 270;", 30); //
	set(L_pan[0], VISIBLE);set(L_pan[1], VISIBLE);set(L_pan[2], VISIBLE);//
	set(L_pan[3], VISIBLE);																//
	///////////////////////////////////////////////////////////////////////
	//THIS IS THE PANEL THAT IS USED TO CHANGE DE CONTROLS
	Lpan = pan_create("pos_y = 0;pos_x = 0;", 30);	set(Lpan, VISIBLE);
	pan_setbutton(Lpan, 0, 0, 50, 10, pr_tga, pg_tga, pb_tga, py_tga, button_0FF, NULL, NULL);
	pan_setbutton(Lpan, 0, 0, 50, 60, pr_tga, pg_tga, pb_tga, py_tga, button_1FF, NULL, NULL);
	pan_setbutton(Lpan, 0, 0, 50, 110, pr_tga, pg_tga, pb_tga, py_tga, button_2FF, NULL, NULL);
	pan_setbutton(Lpan, 0, 0, 50, 160, pr_tga, pg_tga, pb_tga, py_tga, button_3FF, NULL, NULL);
	pan_setbutton(Lpan, 0, 0, 500, 10, pb_tga, pr_tga, py_tga, py_tga, button_4FF, NULL, NULL);
	pan_setbutton(Lpan, 0, 0, 500, 80, pb_tga, pb_tga, pr_tga, py_tga, button_5FF, NULL, NULL);
	// THE KEY TO BE CHANGED
	pan_setstring(Lpan,0,30,010,my_font,str_create("key up"));
	pan_setstring(Lpan,0,30,060,my_font,str_create("key left"));
	pan_setstring(Lpan,0,30,110,my_font,str_create("key down"));
	pan_setstring(Lpan,0,30,160,my_font,str_create("key right"));
	// THE ACTUAL KEY THAT IS SET
	pan_setstring(Lpan,0,90,010,my_font,key_str[0]);
	pan_setstring(Lpan,0,90,060,my_font,key_str[1]);
	pan_setstring(Lpan,0,90,110,my_font,key_str[2]);
	pan_setstring(Lpan,0,90,160,my_font,key_str[3]);
	//THIS IS A YELLOW LIGHT THAT TURN ON WHEN U MUST PRESS THE NEW KEY
	Lan = pan_create("bmap = py_tga;pos_y = 70;pos_x = 300;", 30);	reset(Lan, VISIBLE);
}

function A(var i)		{if(L_pan[i] != NULL)set(L_pan[i], VISIBLE);}
function B(var i)		{if(L_pan[i] != NULL)reset(L_pan[i], VISIBLE);}
function C()			{set(Lan, VISIBLE);	}
function D()			{reset(Lan, VISIBLE);}

function Manage()
{
	var i;
	while(1)
	{
		pan_setstring(Lpan,5,90,010,my_font,key_str[0]);//this four lines manage the 2nd line of strings
		pan_setstring(Lpan,6,90,060,my_font,key_str[1]);//(those that shows what key active each functions)
		pan_setstring(Lpan,7,90,110,my_font,key_str[2]);
		pan_setstring(Lpan,8,90,160,my_font,key_str[3]);
		for(i = 0; i <= 300; i += 1)							//use FOR function this way for use all the keys
		{
			if(CCKVA_A[i] == 1)									//put the function to be excecuted if any key is pressed 
			{A(i);}													//inside this brackets
			
			if(CCKVA_A[i] == 0)									//put the function to be excecuted if any key is not pressed
			{B(i);}													//inside this brackets
		}
		if(CCKVA_B == 1){C();}									//function if someone try to change a key(show a message or in this case a yellow light)
		if(CCKVA_B == 2){D();}									//function when the player end the key change(hide a message or in this case a yellow light)
		wait(1);
	}
}

function main()
{
	fps_max = 60; // limit the frame rate to 60 fps
	video_mode = 8; // run at 1024 x 768 pixels
	video_screen = 2;
	vec_set(screen_color, vector(0, 0, 0)); // make the background color black
	mouse_mode = 4;
	custom_controls(4);
	Change_Keys_PANEL();
	Manage();
}